Attribute VB_Name = "mEnumResource"
Dim tv As TreeView, nd As Node
Dim m_wLangID As Integer

Function ResLanguagesCallBack(ByVal hMod As Long, ByVal ResType As Long, ByVal ResName As Long, ByVal wLangID As Integer, ByVal lParam As Long) As Long
    If wLangID Then m_wLangID = wLangID
    ResLanguagesCallBack = 1 'True
End Function

Function ResTypesCallBack(ByVal hMod As Long, ByVal ResType As Long, ByVal lParam As Long) As Long
    Dim nd As Node
    If (ResType And &HFFFF0000) = 0 Then
        Set nd = tv.Nodes.Add(tv.Nodes.Item(1), tvwChild, "#" & CStr(ResType), ResTypeName(ResType), 2, 3)
        tv.Nodes.Add nd, tvwChild, , "Dummy"
    Else    ' The resource type is defined by a string
        Set nd = tv.Nodes.Add(tv.Nodes.Item(1), tvwChild, , StrFromPtrA(ResType), 2, 3)
        tv.Nodes.Add nd, tvwChild, , "Dummy"
    End If
    Set nd = Nothing
    ResTypesCallBack = True
End Function

Function ResNamesCallBack(ByVal hMod As Long, ByVal ResType As Long, ByVal ResId As Long, ByVal lParam As Long) As Long
    If (ResId And &HFFFF0000) <> 0 Then
       tv.Nodes.Add nd, tvwChild, , StrFromPtrA(ResId), 4, 4
    Else
       tv.Nodes.Add nd, tvwChild, , CStr(ResId), 4, 4
    End If
    ResNamesCallBack = True
End Function

Public Function FillResTypes(ByVal tvw As TreeView, ByVal sFileName As String, ByVal sLibName As String)
   Dim ret As Long
   Set tv = tvw
   tv.Nodes.Clear
   tv.Nodes.Add , , sFileName, sLibName, 1, 1
   Call InitResource(sFileName)
   If hModule Then ret = EnumResourceTypes(hModule, AddressOf ResTypesCallBack, 0)
   tv.Refresh
   tv.Nodes.Item(1).Expanded = True
   Set tv = Nothing
End Function

Public Function FillResNames(ByVal tvw As TreeView, ByVal nod As Node)
   Dim ret As Long
   Set tv = tvw
   Set nd = nod
   If nd.key = "" Then
      ret = EnumResourceNames(hModule, nd.Text, AddressOf ResNamesCallBack, 0)
   Else
      ret = EnumResourceNamesById(hModule, CLng(Mid(nd.key, 2)), AddressOf ResNamesCallBack, 0)
   End If
   Set tv = Nothing
   Set nd = Nothing
End Function

Public Function GetResourceLanguage(ByVal ResType As String, ByVal ResName As String) As Integer
   Dim ret As Long
   Dim lngType As Long
   Dim lngName As Long
   Dim abType() As Byte
   Dim abName() As Byte
   
   If Left(ResType, 1) = "#" Then ResType = Mid(ResType, 2)
   If Left(ResName, 1) = "#" Then ResName = Mid(ResName, 2)
   
   If IsNumeric(ResType) Then
      lngType = CLng(ResType)
   Else
      abType = StrConv(ResType & Chr(0), vbFromUnicode)
      lngType = VarPtr(abType(0))
   End If
   
   If IsNumeric(ResName) Then
      lngName = CLng(ResName)
   Else
      abName = StrConv(ResName & Chr(0), vbFromUnicode)
      lngName = VarPtr(abName(0))
   End If
   ret = EnumResourceLanguages(hModule, lngType, lngName, AddressOf ResLanguagesCallBack, 0)
   GetResourceLanguage = m_wLangID
End Function
